/*
 * Copyright (c) 1997.  Netscape Communications Corporation.  All
 * rights reserved.
 * 
 * Modify an entry:
 *  - replace any existing values in the "mail" attribute with "babs@ace.com"
 *  - add a new value to the "description" attribute
 *
 */
import java.io.*;
import java.net.*;

import netscape.ldap.*;
import java.util.*;

public class ModAttrs1 {
    public static void main( String[] args )
	{
		String ENTRYDN = "file3,cn=Erol Akarsu,hn=Origin200, o=NCSA, o=WebFlow, c=US";

		LDAPModificationSet mods = new LDAPModificationSet();
		String fileContent = readFileContent("README")+"\nErol akars";
		//LDAPAttribute attrEmail = new LDAPAttribute( "mail", "babs@ace.com" );
		LDAPAttribute attrEmail = new LDAPAttribute( "content", fileContent);
		mods.add( LDAPModification.REPLACE, attrEmail );
		LDAPAttribute attrDesc = new LDAPAttribute( "description",
				   "This entry was modified with the modattrs program" );
		//mods.add( LDAPModification.ADD, attrDesc );

		LDAPConnection ld = null;
		int status = -1;
		try {
			ld = new LDAPConnection();
			/* Connect to server */
			String MY_HOST = "osprey4.npac.syr.edu";
			int MY_PORT = 2323;
			ld.connect( MY_HOST, MY_PORT );

			/* Authenticate to the server as directory manager */
			String MGR_DN = "cn=Directory Manager";
			String MGR_PW = "secretdog";
			ld.authenticate( null,null);//MGR_DN, MGR_PW );

			/* Now modify the entry in the directory */
			ld.modify( ENTRYDN, mods );
			System.out.println( "Entry modified"  );
		}
		catch( LDAPException e ) {
			if ( e.getLDAPResultCode() == LDAPException.NO_SUCH_OBJECT )
				System.out.println( "Error: No such entry" );
			else if ( e.getLDAPResultCode() ==
					  LDAPException.INSUFFICIENT_ACCESS_RIGHTS )
				System.out.println( "Error: Insufficient rights" );
			else if ( e.getLDAPResultCode() ==
					  LDAPException.ATTRIBUTE_OR_VALUE_EXISTS )
				System.out.println( "Error: Attribute or value exists" );
			else
				System.out.println( "Error: " + e.toString() );
		}

		/* Done, so disconnect */
		if ( (ld != null) && ld.isConnected() ) {
			try {
			    ld.disconnect();
			} catch ( LDAPException e ) {
				System.out.println( "Error: " + e.toString() );
			}
		}
		System.exit(status);
    }

   public static String readFileContent(String filename)
   {
     char[] data = null;
     File file = new File(filename);
 
     if ((!file.exists())||(!file.canRead())){
       System.out.println("File:"+filename+
                          " doesn't exist or I can not read it");
       return null;
     }
 
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

}
